local AddonLoaded=false
local FirstRun=true
local TitleSelected=-1

local function TitleUpdate()
    if FirstRun then
        if TitleFixSelected then --Should only fail if char has no saved title (due to addon being newly installed)
            if TitleFixSelected~=GetCurrentTitle() then
                --SetCurrentTitle(TitleFixSelected) This is protected
                TitleSelected=TitleFixSelected --Store the current state as it may be overwritten until user responds (code does not halt when prompt is open)
                StaticPopup_Show ("TITLEFIX")
            end
        end
        FirstRun=false
    elseif not UnitAffectingCombat("player") then --maybe better to not do this in combat (not sure how resource intensive it is, likely negligible)
        --print(GetCurrentTitle()) --debugging
        if GetCurrentTitle()~=0 then --0 is not a valid title (-1 is "no title") but sometimes ends up as the saved title,
            --most likely when this update function is called exactly when the log-out is happening (c.f. bug during log-out below)
            TitleFixSelected=GetCurrentTitle()
        end
    end
end

local function RestoreTitle()
    if IsTitleKnown(TitleSelected) or TitleSelected==-1 then --IsTitleKnow returns false on no title
        SetCurrentTitle(TitleSelected)
        if TitleSelected==-1 then
            print('Removed title')
        else
            print('Set title to ' .. GetTitleName(TitleSelected))
        end
    else --Could happen if kicked from guild while offline or due to some error with the save.
        print('Saved title unknown. Nothing updated.')
    end
end

local AddonLoadedFrame=CreateFrame("Frame")
AddonLoadedFrame:RegisterEvent("ADDON_LOADED")
AddonLoadedFrame:SetScript("OnEvent",
    function(self,event,...)
        local AddonName=...
        if AddonName=="TitleFix" then
            AddonLoaded=true
            print("TitleFix loaded")
            local myTicker = C_Timer.NewTicker(5, TitleUpdate)

            StaticPopupDialogs["TITLEFIX"] = {
                text = "Title seems to have gone missing during relog. Restore old one?",
                button1 = "Yes",
                button2 = "No",
                OnAccept = function()
                    RestoreTitle()
                end,
                timeout = 0,
                whileDead = true,
                hideOnEscape = false,
                preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
              }

        end
    end)

--THIS DOESN'T SEEM TO WORK, SEEMS THAT GetCurrentTitle() RETURNS 0 DURING EXITING CLIENT
--local PlayerLeaveFrame=CreateFrame("Frame")
--PlayerLeaveFrame:RegisterEvent("PLAYER_LEAVING_WORLD")
--PlayerLeaveFrame:RegisterEvent("PLAYER_LOGOUT")
--PlayerLeaveFrame:SetScript("OnEvent",
--    function(self,event,...)
--        TitleFixSelected=GetCurrentTitle()
--    end)